/* ############################# MPC License ############################## */
/* # Wed Nov 19 15:19:19 CET 2008                                         # */
/* # Copyright or (C) or Copr. Commissariat a l'Energie Atomique          # */
/* # Copyright or (C) or Copr. 2010-2012 Université de Versailles         # */
/* # St-Quentin-en-Yvelines                                               # */
/* #                                                                      # */
/* # IDDN.FR.001.230040.000.S.P.2007.000.10000                            # */
/* # This file is part of the MPC Runtime.                                # */
/* #                                                                      # */
/* # This software is governed by the CeCILL-C license under French law   # */
/* # and abiding by the rules of distribution of free software.  You can  # */
/* # use, modify and/ or redistribute the software under the terms of     # */
/* # the CeCILL-C license as circulated by CEA, CNRS and INRIA at the     # */
/* # following URL http://www.cecill.info.                                # */
/* #                                                                      # */
/* # The fact that you are presently reading this means that you have     # */
/* # had knowledge of the CeCILL-C license and that you accept its        # */
/* # terms.                                                               # */
/* #                                                                      # */
/* # Authors:                                                             # */
/* #   - PERACHE Marc marc.perache@cea.fr                                 # */
/* #   - DIDELOT Sylvain sylvain.didelot@exascale-computing.eu            # */
/* #                                                                      # */
/* ######################################################################## */

#ifndef __SCTK__IB_ASYNC_H_
#define __SCTK__IB_ASYNC_H_

#include "infiniband/verbs.h"
#include "ib.h"

struct sctk_rail_info_s;

/** \brief This function creates the async event processing thread for each rail
 * \param rail_ib Target rail
 *
 * In this function a system_scope thread processing IB asynchronous calls
 * is created. It allows the monitoring of card events for rail context.
 */
void _mpc_lowcomm_ib_async_init ( struct sctk_rail_info_s *rail_ib );
void _mpc_lowcomm_ib_async_finalize( struct sctk_rail_info_s * rail_ib);

#endif
