/* ############################# MPC License ############################## */
/* # Wed Nov 19 15:19:19 CET 2008                                         # */
/* # Copyright or (C) or Copr. Commissariat a l'Energie Atomique          # */
/* #                                                                      # */
/* # IDDN.FR.001.230040.000.S.P.2007.000.10000                            # */
/* # This file is part of the MPC Runtime.                                # */
/* #                                                                      # */
/* # This software is governed by the CeCILL-C license under French law   # */
/* # and abiding by the rules of distribution of free software.  You can  # */
/* # use, modify and/ or redistribute the software under the terms of     # */
/* # the CeCILL-C license as circulated by CEA, CNRS and INRIA at the     # */
/* # following URL http://www.cecill.info.                                # */
/* #                                                                      # */
/* # The fact that you are presently reading this means that you have     # */
/* # had knowledge of the CeCILL-C license and that you accept its        # */
/* # terms.                                                               # */
/* #                                                                      # */
/* # Authors:                                                             # */
/* #   - PERACHE Marc marc.perache@cea.fr                                 # */
/* #   - ADAM Julien adamj@paratools.com                                  # */
/* #                                                                      # */
/* ######################################################################## */

#ifndef MPC_ACCL_H
#define MPC_ACCL_H

#include <stdio.h>
#include <mpc_config.h>

#ifdef MPC_USE_CUDA
#include <mpc_thread_cuda.h>
#endif

#ifdef MPC_USE_OPENACC
#error "OpenACC support does not exist yet with MPC !"
#endif

#ifdef MPC_USE_OPENCL
#error "OpenCL support does not exist yet with MPC !"
#endif

void sctk_accl_init();
size_t sctk_accl_get_nb_devices();

#endif
