#!/bin/sh
############################# MPC License ##############################
# Wed Nov 19 15:19:19 CET 2008                                         #
# Copyright or (C) or Copr. Commissariat a l'Energie Atomique          #
#                                                                      #
# IDDN.FR.001.230040.000.S.P.2007.000.10000                            #
# This file is part of the MPC Runtime.                                #
#                                                                      #
# This software is governed by the CeCILL-C license under French law   #
# and abiding by the rules of distribution of free software.  You can  #
# use, modify and/ or redistribute the software under the terms of     #
# the CeCILL-C license as circulated by CEA, CNRS and INRIA at the     #
# following URL http://www.cecill.info.                                #
#                                                                      #
# The fact that you are presently reading this means that you have     #
# had knowledge of the CeCILL-C license and that you accept its        #
# terms.                                                               #
#                                                                      #
# Authors:                                                             #
#   - CARRIBAULT Patrick patrick.carribault@cea.fr                     #
#   - PERACHE Marc marc.perache@cea.fr                                 #
#   - JAEGER Julien julien.jaeger@cea.fr                               #
#                                                                      #
########################################################################

SCRIPT=$(readlink -f "$0")
SCRIPTPATH=$(dirname "$SCRIPT")

command -v uncrustify

if test "x$?" = "x0"; then
	echo "Formatting with uncrustify config ${SCRIPTPATH}/uncrustify.cfg"
	uncrustify -c "${SCRIPTPATH}/uncrustify.cfg" --replace "$@"
	exit 0
fi

command -v clang-format

if test "x$?" = "x0"; then
	echo "Formatting with uncrustify config ${SCRIPTPATH}/../.clang-format"
	clang-format -style=file -i "$@"
	exit 0
fi

echo "Could not locate uncrustify or clang format"
